<script lang="ts">
  /* eslint-disable no-param-reassign */
  import {
    dragStore,
    updateDragStore,
  } from 'stores/kanbanStore';
  import priorityIconByValue from 'utils/priorityIconByValue';
  import issueTypeIconByValue from 'utils/issueTypeIconByValue';
  import PersonIcon from 'icons/PersonIcon';
  import IssueDialog from 'components/IssueDialog';
  import { collaborators } from 'stores/authStore';

  export let id;
  export let shortId;
  export let issueType;
  export let summary;
  export let description;
  export let priority;
  export let assigneeId;
  export let column;
  export let createdAt;
  export let updatedAt;

  const TRIM_LENGTH = 80;

  let isDragEnabled = false;

  let tx = 0;
  let ty = 0;
  let width;

  let startX = 0;
  let startY = 0;

  let showModal = false;
  let satisfyClickRequest = false;

  const handleShowModal = () => {
    if (!satisfyClickRequest) return;
    showModal = true;
    satisfyClickRequest = false;
  };

  const handleCloseModal = () => showModal = false;

  const handleDragStart = (event) => {
    satisfyClickRequest = true;
    startX = event.clientX;
    startY = event.clientY;
    updateDragStore({
      sourceColumn: column,
      issueId: id,
      mouseX: event.clientX,
      mouseY: event.clientY,
    });
    isDragEnabled = true;
  };

  const handleDrag = (event) => {
    if (!isDragEnabled) return;
    tx = event.clientX - startX;
    ty = event.clientY - startY;
    updateDragStore({
      isDragging: true,
      mouseX: event.clientX,
      mouseY: event.clientY,
    });
    satisfyClickRequest = false;
  };

  const handleDragEnd = () => {
    isDragEnabled = false;
    tx = 0;
    ty = 0;
  };

  $: draggingThis = isDragEnabled && $dragStore.isDragging;
  $: assigneeName = $collaborators?.find((collabs) => assigneeId === collabs.id)?.name;
</script>

<div
  bind:clientWidth={width}
  on:click={handleShowModal}
  on:mousedown={handleDragStart}
  on:mousemove={handleDrag}
  on:mouseup={handleDragEnd}
  class="select-none rounded-lg cursor-move p-2 mb-2 bg-slate-50 dark:bg-gray-700
    hover:bg-gray-200 hover:dark:bg-gray-900 {draggingThis ? 'z-10 absolute shadow-2xl' : ''}"
  style="{draggingThis ? `width: ${width}px;` : ''} transform: translate({tx}px, {ty}px);"
>
  <div class="flex justify-between items-start">
    <h3 class="dark:text-white text-lg mb-2">{summary}</h3>
    <span class="p-0.5">
      <svelte:component this={priorityIconByValue(priority)} />
    </span>
  </div>
  <p class="text-gray-400 dark:text-gray-400 text-sm">{description.slice(0, TRIM_LENGTH)}{description.length > TRIM_LENGTH ? '...' : ''}</p>
  <pre>{'\n'}</pre>
  <div class="text-gray-500 dark:text-gray-400 flex justify-between">
    <span class="flex items-center gap-1.5">
      <svelte:component this={issueTypeIconByValue(issueType)} />
      {shortId}
    </span>
    <span class="flex items-center gap-1.5">
      <PersonIcon />
      {assigneeName || 'Unassigned'}
    </span>
  </div>
</div>
<IssueDialog
  show={showModal}
  onClose={handleCloseModal}
  {id}
  {shortId}
  {issueType}
  {summary}
  {column}
  {description}
  {priority}
  {assigneeId}
  {createdAt}
  {updatedAt}
/>
